=== debian/changelog ===
rhonabwy (1.1.2-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Thu, 18 Nov 2021 12:23:32 -0500

rhonabwy (1.1.1-2) unstable; urgency=medium

  * d/patches/test: Disable test_rhonabwy_jwks_search
  * d/copyright: update year to 2021

 -- Nicolas Mora <babelouest@debian.org>  Tue, 16 Nov 2021 08:00:34 -0500

rhonabwy (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * d/control: new package name
  * d/control: Upgrade Standards-Version to 4.6.0 (No change)
  * d/patch: remove bugfixes.patch and library_info.patch
  * d/patch: Add test.patch to disable tests when webservices
    run on https, otherwise sbuild and autopkgtest fail
  * d/symbols: Update symbols table
  * d/salsa-ci.yml: enable salsa CI
  * d/source: add lintian-overrides

 -- Nicolas Mora <babelouest@debian.org>  Sun, 07 Nov 2021 07:58:55 -0500
