## rhonabwy 1.1.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # CMake file used to build all programs
 #
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
-# Copyright 2021 Nicolas Mora <mail@babelouest.org>
+# Copyright 2021-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the MIT License
@@ -30,10 +30,10 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/rhonabwy/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "1")
-set(LIBRARY_VERSION_PATCH "2")
-set(ORCANIA_VERSION_REQUIRED "2.2.1")
-set(YDER_VERSION_REQUIRED "1.4.14")
-set(ULFIUS_VERSION_REQUIRED "2.7.6")
+set(LIBRARY_VERSION_PATCH "8")
+set(ORCANIA_VERSION_REQUIRED "2.3.0")
+set(YDER_VERSION_REQUIRED "1.4.17")
+set(ULFIUS_VERSION_REQUIRED "2.7.10")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -62,7 +62,8 @@
 
 # cmake modules
 
-set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+set(R_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
+list(APPEND CMAKE_MODULE_PATH "${R_CMAKE_MODULE_PATH}")
 
 include(GNUInstallDirs)
 include(CheckSymbolExists)
@@ -348,7 +349,7 @@
         )
 
         configure_file(
-                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
+                "${R_CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                 @ONLY)
 
@@ -360,8 +361,3 @@
                     WORKING_DIRECTORY ${TST_DIR}
                     COMMAND ${t})
         endforeach ()
-    endif ()
-endif ()
-
-# install target
-
