=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2020-2021 Nicolas Mora <mail@babelouest.org>
+# Copyright 2020-2022 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -37,7 +37,7 @@
 OUTPUT=librhonabwy.so
 VERSION_MAJOR=1
 VERSION_MINOR=1
-VERSION_PATCH=2
+VERSION_PATCH=8
 
 ifdef DISABLE_CURL
 R_WITH_CURL=0
@@ -70,8 +70,8 @@
 	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
 	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
 	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
-	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
+	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
 	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
