=== debian/changelog ===
rhonabwy (1.1.8-1) unstable; urgency=medium

  * New upstream release
  * d/patches: remove jwe-32bits.patch

 -- Nicolas Mora <babelouest@debian.org>  Sun, 21 Aug 2022 10:17:25 -0400

rhonabwy (1.1.7-2) unstable; urgency=medium

  * d/patches: fix build for 32 bits architectures
  * dh_auto_test: show error logs on error

 -- Nicolas Mora <babelouest@debian.org>  Sat, 20 Aug 2022 18:18:07 -0400

rhonabwy (1.1.7-1) unstable; urgency=medium

  * New upstream release (Fix CVE-2022-38493)
  * librhonabwy-dev: Install examples/ in package
  * d/control: Update standards version to 4.6.1 (no change)
  * d/librhonabwy1.1.symbols: update symbols
  * d/tests: add missing unit tests

 -- Nicolas Mora <babelouest@debian.org>  Sat, 20 Aug 2022 16:47:14 -0400

rhonabwy (1.1.6-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 04 Jun 2022 22:56:32 -0400

rhonabwy (1.1.5-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Mon, 25 Apr 2022 19:13:33 -0400

rhonabwy (1.1.4-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/librhonabwy1.1.symbols: add symbols r_jwt_token_type and r_jwt_token_typen
  * d/rules: run tests manually
  * d/patches: remove test patch
  * d/control: remove libulfius-dev from librhonabwy-dev dependencies

 -- Nicolas Mora <babelouest@debian.org>  Wed, 13 Apr 2022 07:55:43 -0400
