=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
              , check
              , doxygen
              , gnutls-bin
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/babelouest/rhonabwy
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy.git
@@ -49,7 +49,6 @@
 Depends: librhonabwy1.1 (= ${binary:Version}), ${misc:Depends}
        , liborcania-dev
        , libyder-dev
-       , libulfius-dev
        , libgnutls28-dev
        , libjansson-dev
        , zlib1g-dev
