=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
 	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
-	dh_auto_test --
+	cd build && $(MAKE) test -j1 || (cat Testing/Temporary/LastTest.log && false)
 endif
 
 override_dh_auto_clean:
